
_magneto6_generic_write:
	LNK	#2

;driver.c,28 :: 		void magneto6_generic_write ( uint8_t reg_adr, uint8_t trigger, uint8_t tx_data )
;driver.c,32 :: 		temp_data = reg_adr & TRIGGER_MASK;
	PUSH	W10
	ZE	W10, W0
	AND	W0, #31, W2
;driver.c,33 :: 		temp_data |= trigger << TRIGGER_SHIFT;
	ZE	W11, W0
	SL	W0, #5, W1
	ADD	W14, #0, W0
	IOR.B	W2, W1, [W0]
;driver.c,35 :: 		dev_i2c_start(  );
	PUSH	W12
	CALL	_dev_i2c_start
;driver.c,36 :: 		dev_i2c_write( MAGNETO6_SLAVE_ADR_W );
	MOV.B	#106, W10
	CALL	_dev_i2c_write
;driver.c,37 :: 		dev_i2c_write( temp_data );
	MOV.B	[W14+0], W10
	CALL	_dev_i2c_write
	POP	W12
;driver.c,38 :: 		dev_i2c_write( tx_data );
	MOV.B	W12, W10
	CALL	_dev_i2c_write
;driver.c,39 :: 		dev_i2c_stop(  );
	CALL	_dev_i2c_stop
;driver.c,40 :: 		}
L_end_magneto6_generic_write:
	POP	W10
	ULNK
	RETURN
; end of _magneto6_generic_write

_magneto6_generic_read:
	LNK	#2

;driver.c,42 :: 		uint8_t magneto6_generic_read ( uint8_t reg_adr, uint8_t trigger )
;driver.c,46 :: 		temp_data = reg_adr & TRIGGER_MASK;
	PUSH	W10
	ZE	W10, W0
	AND	W0, #31, W2
;driver.c,47 :: 		temp_data |= trigger << TRIGGER_SHIFT;
	ZE	W11, W0
	SL	W0, #5, W1
	ADD	W14, #0, W0
	IOR.B	W2, W1, [W0]
;driver.c,49 :: 		dev_i2c_start(  );
	CALL	_dev_i2c_start
;driver.c,50 :: 		dev_i2c_write( MAGNETO6_SLAVE_ADR_R );
	MOV.B	#107, W10
	CALL	_dev_i2c_write
;driver.c,51 :: 		dev_i2c_write( temp_data );
	MOV.B	[W14+0], W10
	CALL	_dev_i2c_write
;driver.c,52 :: 		temp_data = dev_i2c_read(  );
	CALL	_dev_i2c_read
	MOV.B	W0, [W14+0]
;driver.c,53 :: 		dev_i2c_stop(  );
	CALL	_dev_i2c_stop
;driver.c,55 :: 		return temp_data;
	MOV.B	[W14+0], W0
;driver.c,56 :: 		}
;driver.c,55 :: 		return temp_data;
;driver.c,56 :: 		}
L_end_magneto6_generic_read:
	POP	W10
	ULNK
	RETURN
; end of _magneto6_generic_read

_magneto6_get_id:

;driver.c,58 :: 		uint8_t magneto6_get_id ( void )
;driver.c,62 :: 		MAGNETO6_TRIGGER_NO );
	PUSH	W10
	PUSH	W11
	CLR	W11
;driver.c,61 :: 		id = magneto6_generic_read( MAGNETO6_REG_TEMP_3_2_ID_AXIS_Z_3_0,
	MOV.B	#5, W10
;driver.c,62 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
;driver.c,63 :: 		id >>= ID_SHIFT;
	ZE	W0, W0
	LSR	W0, #4, W0
;driver.c,64 :: 		id &= ID_MASK;
	ZE	W0, W0
	AND	W0, #3, W0
;driver.c,65 :: 		return id;
;driver.c,66 :: 		}
;driver.c,65 :: 		return id;
;driver.c,66 :: 		}
L_end_magneto6_get_id:
	POP	W11
	POP	W10
	RETURN
; end of _magneto6_get_id

_magneto6_get_type:

;driver.c,68 :: 		uint8_t magneto6_get_type ( void )
;driver.c,72 :: 		MAGNETO6_TRIGGER_NO );
	PUSH	W10
	PUSH	W11
	CLR	W11
;driver.c,71 :: 		dev_type = magneto6_generic_read( MAGNETO6_REG_VERSION,
	MOV.B	#22, W10
;driver.c,72 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
;driver.c,73 :: 		dev_type >>= TYPE_SHIFT;
	ZE	W0, W0
	LSR	W0, #4, W0
;driver.c,74 :: 		dev_type &= TYPE_MASK;
	ZE	W0, W0
	AND	W0, #3, W0
;driver.c,75 :: 		return dev_type;
;driver.c,76 :: 		}
;driver.c,75 :: 		return dev_type;
;driver.c,76 :: 		}
L_end_magneto6_get_type:
	POP	W11
	POP	W10
	RETURN
; end of _magneto6_get_type

_magneto6_get_hw_ver:

;driver.c,78 :: 		uint8_t magneto6_get_hw_ver ( void )
;driver.c,82 :: 		MAGNETO6_TRIGGER_NO );
	PUSH	W10
	PUSH	W11
	CLR	W11
;driver.c,81 :: 		hw_ver = magneto6_generic_read( MAGNETO6_REG_VERSION,
	MOV.B	#22, W10
;driver.c,82 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
;driver.c,83 :: 		hw_ver &= HWV_MASK;
	ZE	W0, W0
	AND	W0, #15, W0
;driver.c,84 :: 		return hw_ver;
;driver.c,85 :: 		}
;driver.c,84 :: 		return hw_ver;
;driver.c,85 :: 		}
L_end_magneto6_get_hw_ver:
	POP	W11
	POP	W10
	RETURN
; end of _magneto6_get_hw_ver

_magneto6_get_temp_value:

;driver.c,87 :: 		int16_t magneto6_get_temp_value ( void )
;driver.c,89 :: 		int16_t temperature_value = 0;
	PUSH	W10
	PUSH	W11
;driver.c,93 :: 		MAGNETO6_TRIGGER_NO );
	CLR	W11
;driver.c,92 :: 		temp_read = magneto6_generic_read( MAGNETO6_REG_TEMP_11_4,
	MOV.B	#3, W10
;driver.c,93 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
;driver.c,94 :: 		temperature_value = temp_read;
; temperature_value start address is: 4 (W2)
	ZE	W0, W2
;driver.c,95 :: 		temperature_value <<= HALF_BYTE_SHIFT;
	SL	W2, #4, W1
	MOV	W1, W2
;driver.c,96 :: 		if ( 0 != ( temp_read  & SIGNED_MASK ) )
	ZE	W0, W1
	MOV	#128, W0
	AND	W1, W0, W0
	CP	W0, #0
	BRA NZ	L__magneto6_get_temp_value15
	GOTO	L__magneto6_get_temp_value8
L__magneto6_get_temp_value15:
;driver.c,98 :: 		temperature_value |= SIGNED_INT16_MASK;
	MOV	#61440, W0
	IOR	W2, W0, W2
; temperature_value end address is: 4 (W2)
;driver.c,99 :: 		}
	GOTO	L_magneto6_get_temp_value0
L__magneto6_get_temp_value8:
;driver.c,96 :: 		if ( 0 != ( temp_read  & SIGNED_MASK ) )
;driver.c,99 :: 		}
L_magneto6_get_temp_value0:
;driver.c,101 :: 		MAGNETO6_TRIGGER_NO );
; temperature_value start address is: 4 (W2)
	PUSH	W2
	CLR	W11
;driver.c,100 :: 		temp_read = magneto6_generic_read( MAGNETO6_REG_TEMP_3_2_ID_AXIS_Z_3_0,
	MOV.B	#5, W10
;driver.c,101 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
	POP	W2
;driver.c,102 :: 		temp_read >>= HALF_BYTE_SHIFT;
	ZE	W0, W0
	LSR	W0, #4, W0
;driver.c,103 :: 		temp_read &= TEMP_LSB_MASK;
	ZE	W0, W0
	AND	W0, #12, W0
;driver.c,104 :: 		temperature_value |= temp_read;
	ZE	W0, W0
	IOR	W2, W0, W1
; temperature_value end address is: 4 (W2)
;driver.c,106 :: 		temperature_value -= TEMPERATURE_OFFSET;
	MOV	#1180, W0
	SUB	W1, W0, W0
;driver.c,107 :: 		temperature_value *= TEMPERATURE_RES;
	ASR	W0, #15, W1
	SETM	W2
	CALL	__Long2Float
	MOV	#49807, W2
	MOV	#15989, W3
	CALL	__Mul_FP
	CALL	__Float2Longint
;driver.c,108 :: 		temperature_value += TEMPERATURE_OFFSET_VAL;
	ADD	W0, #25, W0
;driver.c,110 :: 		return temperature_value;
;driver.c,111 :: 		}
;driver.c,110 :: 		return temperature_value;
;driver.c,111 :: 		}
L_end_magneto6_get_temp_value:
	POP	W11
	POP	W10
	RETURN
; end of _magneto6_get_temp_value

_magneto6_get_axis_value:
	LNK	#4

;driver.c,113 :: 		int16_t magneto6_get_axis_value ( uint8_t axis )
;driver.c,118 :: 		int16_t signed_val = SIGNED_VAL;
	PUSH	W10
	PUSH	W11
	MOV	#63488, W0
	MOV	W0, [W14+2]
;driver.c,120 :: 		switch ( axis )
	GOTO	L_magneto6_get_axis_value1
;driver.c,122 :: 		case MAGNETO6_AXIS_X:
L_magneto6_get_axis_value3:
;driver.c,125 :: 		MAGNETO6_TRIGGER_NO );
	CLR	W11
;driver.c,124 :: 		msb_read = magneto6_generic_read( MAGNETO6_REG_AXIS_X_11_4,
	CLR	W10
;driver.c,125 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
	MOV.B	W0, [W14+0]
;driver.c,127 :: 		MAGNETO6_TRIGGER_NO );
	CLR	W11
;driver.c,126 :: 		lsb_read = magneto6_generic_read( MAGNETO6_REG_AXES_XY_3_0,
	MOV.B	#4, W10
;driver.c,127 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
; lsb_read start address is: 6 (W3)
	MOV.B	W0, W3
;driver.c,129 :: 		break;
	MOV.B	W3, W2
; lsb_read end address is: 6 (W3)
	GOTO	L_magneto6_get_axis_value2
;driver.c,131 :: 		case MAGNETO6_AXIS_Y:
L_magneto6_get_axis_value4:
;driver.c,134 :: 		MAGNETO6_TRIGGER_NO );
	CLR	W11
;driver.c,133 :: 		msb_read = magneto6_generic_read( MAGNETO6_REG_AXIS_Y_11_4,
	MOV.B	#1, W10
;driver.c,134 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
	MOV.B	W0, [W14+0]
;driver.c,136 :: 		MAGNETO6_TRIGGER_NO );
	CLR	W11
;driver.c,135 :: 		lsb_read = magneto6_generic_read( MAGNETO6_REG_AXES_XY_3_0,
	MOV.B	#4, W10
;driver.c,136 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
; lsb_read start address is: 6 (W3)
	MOV.B	W0, W3
;driver.c,137 :: 		break;
	MOV.B	W3, W2
; lsb_read end address is: 6 (W3)
	GOTO	L_magneto6_get_axis_value2
;driver.c,139 :: 		case MAGNETO6_AXIS_Z:
L_magneto6_get_axis_value5:
;driver.c,142 :: 		MAGNETO6_TRIGGER_NO );
	CLR	W11
;driver.c,141 :: 		msb_read = magneto6_generic_read( MAGNETO6_REG_AXIS_Z_11_4,
	MOV.B	#2, W10
;driver.c,142 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
	MOV.B	W0, [W14+0]
;driver.c,144 :: 		MAGNETO6_TRIGGER_NO );
	CLR	W11
;driver.c,143 :: 		lsb_read = magneto6_generic_read( MAGNETO6_REG_TEMP_3_2_ID_AXIS_Z_3_0,
	MOV.B	#5, W10
;driver.c,144 :: 		MAGNETO6_TRIGGER_NO );
	CALL	_magneto6_generic_read
; lsb_read start address is: 6 (W3)
	MOV.B	W0, W3
;driver.c,145 :: 		break;
	MOV.B	W3, W2
; lsb_read end address is: 6 (W3)
	GOTO	L_magneto6_get_axis_value2
;driver.c,147 :: 		default:
L_magneto6_get_axis_value6:
;driver.c,149 :: 		return MAGNETO6_DEV_ERROR;
	MOV	#65535, W0
	GOTO	L_end_magneto6_get_axis_value
;driver.c,151 :: 		}
L_magneto6_get_axis_value1:
	MOV.B	#170, W0
	CP.B	W10, W0
	BRA NZ	L__magneto6_get_axis_value17
	GOTO	L_magneto6_get_axis_value3
L__magneto6_get_axis_value17:
	MOV.B	#187, W0
	CP.B	W10, W0
	BRA NZ	L__magneto6_get_axis_value18
	GOTO	L_magneto6_get_axis_value4
L__magneto6_get_axis_value18:
	MOV.B	#204, W0
	CP.B	W10, W0
	BRA NZ	L__magneto6_get_axis_value19
	GOTO	L_magneto6_get_axis_value5
L__magneto6_get_axis_value19:
	GOTO	L_magneto6_get_axis_value6
L_magneto6_get_axis_value2:
;driver.c,153 :: 		if ( 0 == ( msb_read  & SIGNED_MASK ) )
; lsb_read start address is: 4 (W2)
	ADD	W14, #0, W0
	ZE	[W0], W1
	MOV	#128, W0
	AND	W1, W0, W0
	CP	W0, #0
	BRA Z	L__magneto6_get_axis_value20
	GOTO	L_magneto6_get_axis_value7
L__magneto6_get_axis_value20:
;driver.c,155 :: 		signed_val = UNSGINED_VAL;
	CLR	W0
	MOV	W0, [W14+2]
;driver.c,156 :: 		}
L_magneto6_get_axis_value7:
;driver.c,157 :: 		msb_read &= UNSIGNED_MASK;
	ADD	W14, #0, W0
	ZE	[W0], W1
	MOV	#127, W0
; axis_value start address is: 6 (W3)
	AND	W1, W0, W3
;driver.c,158 :: 		lsb_read &= MAGNETO_LSB_MASK;
	ZE	W2, W0
; lsb_read end address is: 4 (W2)
	AND	W0, #15, W0
;driver.c,159 :: 		axis_value = msb_read;
	ZE	W3, W3
;driver.c,160 :: 		axis_value <<= HALF_BYTE_SHIFT;
	SL	W3, #4, W1
; axis_value end address is: 6 (W3)
;driver.c,161 :: 		axis_value |= lsb_read;
	ZE	W0, W0
	IOR	W1, W0, W1
;driver.c,162 :: 		axis_value += signed_val;
	ADD	W14, #2, W0
	ADD	W1, [W0], W0
;driver.c,163 :: 		return axis_value;
;driver.c,164 :: 		}
;driver.c,163 :: 		return axis_value;
;driver.c,164 :: 		}
L_end_magneto6_get_axis_value:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _magneto6_get_axis_value

_magneto6_get_axes_value:
	LNK	#2

;driver.c,166 :: 		void magneto6_get_axes_value ( magneto6_axes_t *axes )
;driver.c,168 :: 		axes->x = magneto6_get_axis_value( MAGNETO6_AXIS_X );
	PUSH	W10
	MOV	W10, W0
	MOV	W0, [W14+0]
	PUSH	W10
	MOV.B	#170, W10
	CALL	_magneto6_get_axis_value
	POP	W10
	MOV	[W14+0], W1
	MOV	W0, [W1]
;driver.c,169 :: 		axes->y = magneto6_get_axis_value( MAGNETO6_AXIS_Y );
	ADD	W10, #2, W0
	MOV	W0, [W14+0]
	PUSH	W10
	MOV.B	#187, W10
	CALL	_magneto6_get_axis_value
	POP	W10
	MOV	[W14+0], W1
	MOV	W0, [W1]
;driver.c,170 :: 		axes->z = magneto6_get_axis_value( MAGNETO6_AXIS_Z );
	ADD	W10, #4, W0
	MOV	W0, [W14+0]
	MOV.B	#204, W10
	CALL	_magneto6_get_axis_value
	MOV	[W14+0], W1
	MOV	W0, [W1]
;driver.c,171 :: 		}
L_end_magneto6_get_axes_value:
	POP	W10
	ULNK
	RETURN
; end of _magneto6_get_axes_value
