
_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;magneto6.c,44 :: 		void main(  )
;magneto6.c,46 :: 		sys_init(  );
	PUSH	W10
	CALL	_sys_init
;magneto6.c,47 :: 		app_cfg( MAGNETO );
	MOV.B	#2, W10
	CALL	_app_cfg
;magneto6.c,49 :: 		for ( ; ; )
L_main0:
;magneto6.c,51 :: 		app_task(  );
	CALL	_app_task
;magneto6.c,52 :: 		}
	GOTO	L_main0
;magneto6.c,53 :: 		}
L_end_main:
	POP	W10
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main

_sys_init:

;magneto6.c,55 :: 		void sys_init ( void )
;magneto6.c,57 :: 		define_cs( OUTPUT );
	PUSH	W10
	CLR	W10
	CALL	_define_cs
;magneto6.c,58 :: 		define_int( INPUT );
	MOV.B	#1, W10
	CALL	_define_int
;magneto6.c,59 :: 		IEN = 0;
	BCLR	LATC2_bit, BitPos(LATC2_bit+0)
;magneto6.c,60 :: 		dev_i2c_init(  );
	CALL	_dev_i2c_init
;magneto6.c,61 :: 		Delay_ms( 100 );
	MOV	#3, W8
	MOV	#2261, W7
L_sys_init3:
	DEC	W7
	BRA NZ	L_sys_init3
	DEC	W8
	BRA NZ	L_sys_init3
;magneto6.c,62 :: 		log_init(  );
	CALL	_log_init
;magneto6.c,63 :: 		Delay_ms( 100 );
	MOV	#3, W8
	MOV	#2261, W7
L_sys_init5:
	DEC	W7
	BRA NZ	L_sys_init5
	DEC	W8
	BRA NZ	L_sys_init5
;magneto6.c,64 :: 		log_line( " - Init -" );
	MOV	#lo_addr(?lstr1_magneto6), W10
	CALL	_log_line
;magneto6.c,65 :: 		}
L_end_sys_init:
	POP	W10
	RETURN
; end of _sys_init

_app_cfg:

;magneto6.c,67 :: 		void app_cfg ( uint8_t app_type )
;magneto6.c,69 :: 		demo_type = app_type;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	MOV	#lo_addr(magneto6_demo_type), W0
	MOV.B	W10, [W0]
;magneto6.c,73 :: 		MAGNETO6_CFG_ID );
	MOV.B	#192, W12
;magneto6.c,72 :: 		MAGNETO6_TRIGGER_NO,
	CLR	W11
;magneto6.c,71 :: 		magneto6_generic_write( MAGNETO6_REG_CFG,
	MOV.B	#16, W10
;magneto6.c,73 :: 		MAGNETO6_CFG_ID );
	CALL	_magneto6_generic_write
;magneto6.c,76 :: 		MAGNETO6_CTRL1_INT_DISABLE );
	MOV.B	#4, W12
;magneto6.c,75 :: 		MAGNETO6_TRIGGER_NO,
	CLR	W11
;magneto6.c,74 :: 		magneto6_generic_write( MAGNETO6_REG_CTRL_1,
	MOV.B	#17, W10
;magneto6.c,76 :: 		MAGNETO6_CTRL1_INT_DISABLE );
	CALL	_magneto6_generic_write
;magneto6.c,78 :: 		temp_data = magneto6_get_id(  );
	CALL	_magneto6_get_id
	MOV	#lo_addr(magneto6_temp_data), W1
	MOV.B	W0, [W1]
;magneto6.c,79 :: 		ByteToStr( temp_data, demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W11
	MOV.B	W0, W10
	CALL	_ByteToStr
;magneto6.c,80 :: 		log_text( " ID: " );
	MOV	#lo_addr(?lstr2_magneto6), W10
	CALL	_log_text
;magneto6.c,81 :: 		Ltrim( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_Ltrim
;magneto6.c,82 :: 		log_line( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_log_line
;magneto6.c,83 :: 		Delay_ms( 500 );
	MOV	#11, W8
	MOV	#11309, W7
L_app_cfg7:
	DEC	W7
	BRA NZ	L_app_cfg7
	DEC	W8
	BRA NZ	L_app_cfg7
;magneto6.c,84 :: 		temp_data = magneto6_get_type(  );
	CALL	_magneto6_get_type
	MOV	#lo_addr(magneto6_temp_data), W1
	MOV.B	W0, [W1]
;magneto6.c,85 :: 		ByteToStr( temp_data, demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W11
	MOV.B	W0, W10
	CALL	_ByteToStr
;magneto6.c,86 :: 		log_text( " Type: " );
	MOV	#lo_addr(?lstr3_magneto6), W10
	CALL	_log_text
;magneto6.c,87 :: 		Ltrim( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_Ltrim
;magneto6.c,88 :: 		log_line( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_log_line
;magneto6.c,89 :: 		Delay_ms( 500 );
	MOV	#11, W8
	MOV	#11309, W7
L_app_cfg9:
	DEC	W7
	BRA NZ	L_app_cfg9
	DEC	W8
	BRA NZ	L_app_cfg9
;magneto6.c,90 :: 		temp_data = magneto6_get_hw_ver(  );
	CALL	_magneto6_get_hw_ver
	MOV	#lo_addr(magneto6_temp_data), W1
	MOV.B	W0, [W1]
;magneto6.c,91 :: 		ByteToStr( temp_data, demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W11
	MOV.B	W0, W10
	CALL	_ByteToStr
;magneto6.c,92 :: 		Ltrim( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_Ltrim
;magneto6.c,93 :: 		log_text( " HW version: " );
	MOV	#lo_addr(?lstr4_magneto6), W10
	CALL	_log_text
;magneto6.c,94 :: 		log_line( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_log_line
;magneto6.c,96 :: 		switch ( demo_type )
	GOTO	L_app_cfg11
;magneto6.c,98 :: 		case TEMPERATURE:
L_app_cfg13:
;magneto6.c,101 :: 		MAGNETO6_CFG_TEMPEARATURE );
	MOV.B	#64, W12
;magneto6.c,100 :: 		MAGNETO6_TRIGGER_NO,
	CLR	W11
;magneto6.c,99 :: 		magneto6_generic_write( MAGNETO6_REG_CFG,
	MOV.B	#16, W10
;magneto6.c,101 :: 		MAGNETO6_CFG_TEMPEARATURE );
	CALL	_magneto6_generic_write
;magneto6.c,102 :: 		break;
	GOTO	L_app_cfg12
;magneto6.c,103 :: 		case MAGNETO:
L_app_cfg14:
;magneto6.c,106 :: 		MAGNETO6_CFG_MAGNETO );
	MOV.B	#128, W12
;magneto6.c,105 :: 		MAGNETO6_TRIGGER_NO,
	CLR	W11
;magneto6.c,104 :: 		magneto6_generic_write( MAGNETO6_REG_CFG,
	MOV.B	#16, W10
;magneto6.c,106 :: 		MAGNETO6_CFG_MAGNETO );
	CALL	_magneto6_generic_write
;magneto6.c,107 :: 		break;
	GOTO	L_app_cfg12
;magneto6.c,108 :: 		default:
L_app_cfg15:
;magneto6.c,109 :: 		log_line( " - ERROR - " );
	MOV	#lo_addr(?lstr5_magneto6), W10
	CALL	_log_line
;magneto6.c,110 :: 		for( ; ; );
L_app_cfg16:
	GOTO	L_app_cfg16
;magneto6.c,111 :: 		}
L_app_cfg11:
	MOV	#lo_addr(magneto6_demo_type), W0
	MOV.B	[W0], W0
	CP.B	W0, #1
	BRA NZ	L__app_cfg27
	GOTO	L_app_cfg13
L__app_cfg27:
	MOV	#lo_addr(magneto6_demo_type), W0
	MOV.B	[W0], W0
	CP.B	W0, #2
	BRA NZ	L__app_cfg28
	GOTO	L_app_cfg14
L__app_cfg28:
	GOTO	L_app_cfg15
L_app_cfg12:
;magneto6.c,113 :: 		log_line( " - Task - " );
	MOV	#lo_addr(?lstr6_magneto6), W10
	CALL	_log_line
;magneto6.c,114 :: 		}
L_end_app_cfg:
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _app_cfg

_app_task:

;magneto6.c,116 :: 		void app_task ( void )
;magneto6.c,118 :: 		if ( TEMPERATURE == demo_type )
	PUSH	W10
	PUSH	W11
	MOV	#lo_addr(magneto6_demo_type), W0
	MOV.B	[W0], W0
	CP.B	W0, #1
	BRA Z	L__app_task30
	GOTO	L_app_task19
L__app_task30:
;magneto6.c,120 :: 		sens_data = magneto6_get_temp_value( );
	CALL	_magneto6_get_temp_value
	MOV	W0, magneto6_sens_data
;magneto6.c,121 :: 		IntToStr( sens_data, demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W11
	MOV	W0, W10
	CALL	_IntToStr
;magneto6.c,122 :: 		Ltrim( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_Ltrim
;magneto6.c,123 :: 		log_text( " Temperature: " );
	MOV	#lo_addr(?lstr7_magneto6), W10
	CALL	_log_text
;magneto6.c,124 :: 		log_line( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_log_line
;magneto6.c,125 :: 		}
	GOTO	L_app_task20
L_app_task19:
;magneto6.c,128 :: 		magneto6_get_axes_value( &axes_val );
	MOV	#lo_addr(magneto6_axes_val), W10
	CALL	_magneto6_get_axes_value
;magneto6.c,129 :: 		IntToStr( axes_val.x, demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W11
	MOV	magneto6_axes_val, W10
	CALL	_IntToStr
;magneto6.c,130 :: 		Ltrim( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_Ltrim
;magneto6.c,131 :: 		log_text( " X: " );
	MOV	#lo_addr(?lstr8_magneto6), W10
	CALL	_log_text
;magneto6.c,132 :: 		log_line( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_log_line
;magneto6.c,134 :: 		IntToStr( axes_val.y, demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W11
	MOV	magneto6_axes_val+2, W10
	CALL	_IntToStr
;magneto6.c,135 :: 		Ltrim( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_Ltrim
;magneto6.c,136 :: 		log_text( " Y: " );
	MOV	#lo_addr(?lstr9_magneto6), W10
	CALL	_log_text
;magneto6.c,137 :: 		log_line( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_log_line
;magneto6.c,139 :: 		IntToStr( axes_val.z, demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W11
	MOV	magneto6_axes_val+4, W10
	CALL	_IntToStr
;magneto6.c,140 :: 		Ltrim( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_Ltrim
;magneto6.c,141 :: 		log_text( " Z: " );
	MOV	#lo_addr(?lstr10_magneto6), W10
	CALL	_log_text
;magneto6.c,142 :: 		log_line( demo_txt );
	MOV	#lo_addr(magneto6_demo_txt), W10
	CALL	_log_line
;magneto6.c,143 :: 		}
L_app_task20:
;magneto6.c,145 :: 		log_line( "----------------------" );
	MOV	#lo_addr(?lstr11_magneto6), W10
	CALL	_log_line
;magneto6.c,146 :: 		Delay_ms( 1000 );
	MOV	#21, W8
	MOV	#22619, W7
L_app_task21:
	DEC	W7
	BRA NZ	L_app_task21
	DEC	W8
	BRA NZ	L_app_task21
;magneto6.c,147 :: 		}
L_end_app_task:
	POP	W11
	POP	W10
	RETURN
; end of _app_task
